- [HTTP request](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#body.request_body)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#body.response_body)
- [AsynchronousRefundResponse](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResponse)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResponse.SCHEMA_REPRESENTATION)
- [AsynchronousRefundResult](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResult)
  - [JSON representation](https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResult.SCHEMA_REPRESENTATION)

Refunds a portion of or the entire redirect payment. The `requestId` within the header is the idempotency key, which uniquely identifies this transaction.

This initiates a request to refund funds from a redirect payment. The amount refunded can be equal to or smaller than the remaining payment amount on the transaction. Multiple partial refunds are allowed by calling `redirect-fop-v1.asynchronousRefund` multiple times with different `requestId` values within the header. The final result of the refund is supplied by a call to `refundResultNotification`.

If the endpoint encounters an error while processing the request, the response body from this endpoint should be of type `https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ErrorResponse`.

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1
        },
        "requestId": "qierozie12345",
        "requestTimestamp": {
          "epochMillis": "1481899949606"
        },
        "paymentIntegratorAccountId": "InvisiRedirectPaymentUSA_USD"
      },
      "captureRequestId": "cmVxdWVzdDE",
      "refundAmount": {
        "amountMicros": "109900000",
        "currencyCode": "INR"
      }
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": {
          "epochMillis": "1481899949611"
        }
      },
      "result": {
        "acknowledged": {}
      }
    }

### HTTP request

`POST https://www.integratorhost.example.com/integrator-base-path/v1/payment-integrator-redirect/asynchronousRefund`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RequestHeader`) }, "captureRequestId": string, "refundAmount": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Amount`) } } ``` |

| Fields ||
|---|---|
| `requestHeader` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/RequestHeader`)`` **REQUIRED**: Common header for all requests. |
| `captureRequestId` | `string` **REQUIRED** : Unique identifier for this redirect payment. This is the `requestId` field generated by Google when the redirect payment began. For example, if Google called `generateRedirectPaymentUrl` to generate the Redirect URL, this identifier will be set to the `requestId` in the `requestHeader` of that call. |
| `refundAmount` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Amount`)`` **REQUIRED**: The amount of the refund. This will be a positive number, and should always be less-than or equal-to the remaining balance for the completed redirect payment. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/redirect-fop-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResponse`)`` |
| HTTP 4XX / 5XX Status | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ErrorResponse`)`` |
| End of mutually exclusive fields. ||

## AsynchronousRefundResponse

Response object for the `refund` method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ResponseHeader`) }, "result": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResult`) } } ``` |

| Fields ||
|---|---|
| `responseHeader` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/ResponseHeader`)`` **REQUIRED**: Common header for all responses. |
| `result` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/asynchronousRefund#AsynchronousRefundResult`)`` **REQUIRED**: Result of this asynchronous refund. |

## AsynchronousRefundResult

Result of this asynchronous refund.

| JSON representation |
|---|
| ``` { // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "acknowledged": { object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| **REQUIRED**: The result of the asynchronous refund. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `acknowledged` | ``object (`https://developers.google.com/pay/redirect-fop-v1/payment-integrator-redirect-fop-api/Empty`)`` The refund has been requested and the integrator will do additional steps to determine if the refund was successful. Once the integrator knows the result of the refund, they will inform Google of the result by calling the `refundResultNotification` API. |
| End of mutually exclusive fields. ||